using UnityEngine;
using System.Collections;
using System.Collections.Generic;

enum BoolQ {
	TRUE,
	FALSE,
	NULL
}

public class SBPreferencesGUI : MonoBehaviour {

	private const string OnLineDictionary= "SBPreferences";

	private string log= "";
	private string key= "Key4";
	private string val= "Reading...";
	private string val1= "Reading...";
	private string val2= "Reading...";
	private string val3= "Reading...";
	private SBPrefStatus lastStat= SBPrefStatus.NOT_REQUESTED;


	// START
	//
	public void Start() {
		// read in the default values
		StartCoroutine(this.ReadDictionary(OnLineDictionary));
	}


	public IEnumerator ReadDictionary(string dict) {
		yield return StartCoroutine(SBPreferences.ReadPreferencesCoroutine(dict));
		this.val1= SBPreferences.GetString("Key1", "Empty");
		this.val2= SBPreferences.GetString("Key2", "Empty");
		this.val3= SBPreferences.GetString("Key3", "Empty");
		this.val= SBPreferences.GetString("Key4", "Empty");
	}
	
	
	// ON GUI
	//
	public void OnGUI() {
		Vector2 startGUI= new Vector2(10f, 10f);

		// AREA TO OUTPUT TO		
		GUI.TextArea(new Rect(startGUI.x, startGUI.y, 500f, 250f), log);
		

		// READ / WRITE DICTIONARY
		startGUI.y+= 260f;
		if (lastStat != SBPreferences.Status) {
			// print the status, if it has changed
			SBLog("Status: " + SBPreferences.Status + " |" + SBPreferences.Message + "|");
		}
		lastStat= SBPreferences.Status;

		// if SBPreferences is idle, then provide the Read/Write buttons
		if (SBPreferences.Status == SBPrefStatus.READY || SBPreferences.Status == SBPrefStatus.NOT_REQUESTED || SBPreferences.Status == SBPrefStatus.ERROR) {  // have them or error
			if (GUI.Button(new Rect(startGUI.x+110f, startGUI.y, 100f, 20f), "Write Database")) {
				SBPreferences.SetString("Key1", this.val1);
				SBPreferences.SetString("Key2", this.val2);
				SBPreferences.SetString("Key3", this.val3);
				SBPreferences.SetString("Key4", this.val);
				SBLog("Writing Database: " + OnLineDictionary);
				SBPreferences.WritePreferences(OnLineDictionary);
			}
			if (GUI.Button(new Rect(startGUI.x+320f, startGUI.y, 100f, 20f), "Read Database")) {
				SBLog("Reading Database:" + OnLineDictionary);
				StartCoroutine(this.ReadDictionary(OnLineDictionary));
			}
		} else {  //else we are loading
			GUI.Label(new Rect(startGUI.x, startGUI.y, 100f, 20f), "Loading...");
		}
		
		// KEY / VALUE STRINGS
		startGUI.y+= 30f;
		GUI.Label(new Rect(startGUI.x, startGUI.y, 150f, 20f), "Key1");
		val1= GUI.TextField(new Rect(startGUI.x+160f, startGUI.y, 340f, 20f), val1);

		startGUI.y+= 30f;
		GUI.Label(new Rect(startGUI.x, startGUI.y, 150f, 20f), "Key2");
		val2= GUI.TextField(new Rect(startGUI.x+160f, startGUI.y, 340f, 20f), val2);

		startGUI.y+= 30f;
		GUI.Label(new Rect(startGUI.x, startGUI.y, 150f, 20f), "Key3");
		val3= GUI.TextField(new Rect(startGUI.x+160f, startGUI.y, 340f, 20f), val3);

		startGUI.y+= 30f;
		key= GUI.TextField(new Rect(startGUI.x, startGUI.y, 150f, 20f), key);
		val= GUI.TextField(new Rect(startGUI.x+160f, startGUI.y, 340f, 20f), val);
	}


	// SB Log
	//
	private void SBLog(string addText) {
		if (! addText.EndsWith("\n")) {
			addText+= "\n";
		}
		log+= addText;
	}
}
